freeslot(
	"S_NSPLEENIK_SWIM_IDLE",
	"S_NSPLEENIK_SWIM"
)

states[S_NSPLEENIK_SWIM_IDLE] = {
	sprite = SPR_PLAY,
	frame = SPR2_CLNG|A,
	tics = -1,
	nextstate = S_NULL
}

states[S_NSPLEENIK_SWIM] = {
	sprite = SPR_PLAY,
	frame = SPR2_SWIM|FF_ANIMATE,
	tics = 12,
	var1 = 2,
	var2 = 4,
	nextstate = S_NSPLEENIK_SWIM_IDLE
}

addHook("PlayerThink", function(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.health < 1 then return end
	if p.mo.skin ~= "spleenik" then return end
	if p.powers[pw_carry] == CR_NIGHTSMODE then return end
	
	if (not (p.cmd.buttons & BT_JUMP)) and (not P_IsObjectOnGround(p.mo)) then
		p.SPLEENIKjumpready = true
		p.SPLEENIKjumptap = false
	elseif p.SPLEENIKjumpready then
		p.SPLEENIKjumpready = false
		p.SPLEENIKjumptap = true
	else
		p.SPLEENIKjumptap = false
	end
	
	if (not (p.cmd.buttons & BT_USE)) and (not P_IsObjectOnGround(p.mo)) then
		p.SPLEENIKspinready = true
		p.SPLEENIKspintap = false
	elseif p.SPLEENIKspinready then
		p.SPLEENIKspinready = false
		p.SPLEENIKspintap = true
	else
		p.SPLEENIKspintap = false
	end
	
	if P_IsObjectOnGround(p.mo) or P_PlayerInPain(p) then
		p.SPLEENIKsprung = 0
	end
	
	if not p.SPLEENIKsprung then
		if p.mo.state == S_NSPLEENIK_SWIM and not (p.mo.eflags & MFE_UNDERWATER) then
			p.mo.state = S_PLAY_SPRING
			p.pflags = $|PF_JUMPED
			p.charflags = $ & ~SF_MARIODAMAGE
			if p.mo.momz*P_MobjFlip(p.mo) > P_MobjFlip(p.mo)*FRACUNIT then
				P_SetObjectMomZ(p.mo, 10*p.jumpfactor, false)
			end
		elseif p.mo.state == S_NSPLEENIK_SWIM_IDLE and not (p.mo.eflags & MFE_UNDERWATER) then
			p.mo.state = S_PLAY_FALL
			p.pflags = $|PF_JUMPED
			p.charflags = $ & ~SF_MARIODAMAGE
		elseif p.mo.state == S_NSPLEENIK_SWIM_IDLE and P_IsObjectOnGround(p.mo) then
			p.mo.state = S_PLAY_STND 
		elseif (p.mo.eflags & MFE_UNDERWATER) and not (p.SPLEENIKcrouch or p.SPLEENIKcrawl or p.SPLEENIKroll or p.SPLEENIKdive or p.fluffymoonwalking) then
			p.pflags = $ & ~PF_JUMPED
			p.charflags = $|SF_MARIODAMAGE
			if p.mo.state ~= S_NSPLEENIK_SWIM_IDLE and p.mo.state ~= S_NSPLEENIK_SWIM and (p.mo.state ~= S_PLAY_STND and not P_IsObjectOnGround(p.mo)) then
				p.mo.state = S_NSPLEENIK_SWIM_IDLE
			end
		end
	else
		if p.mo.state == S_NSPLEENIK_SWIM_IDLE or p.mo.state == S_NSPLEENIK_SWIM then
			if p.mo.momz*P_MobjFlip(p.mo) > 0 then
				p.mo.state = S_PLAY_SPRING
			else
				p.mo.state = S_PLAY_FALL
			end
		end
	end
	
	if (p.mo.eflags & MFE_SPRUNG) then
		p.SPLEENIKsprung = 1
	end
end)

addHook("JumpSpecial", function(p)
	if p.mo.health < 1 then return end
	if p.mo.skin ~= "spleenik" then return end
	if p.powers[pw_carry] then return end
	if (p.pflags & PF_STASIS) or (p.pflags & PF_JUMPSTASIS) or (p.pflags & PF_FULLSTASIS) then return false end
	if (p.SPLEENIKjumptap) and (p.mo.eflags & MFE_UNDERWATER) and (not (p.pflags & PF_SLIDING)) and (not p.powers[pw_carry]) and not (p.SPLEENIKcrouch or p.SPLEENIKcrawl or p.SPLEENIKroll or p.SPLEENIKsprung) then
		p.mo.state = S_NSPLEENIK_SWIM
		P_SpawnSkidDust(p, p.mo.radius/2, false)
		if not p.powers[pw_super] then
			if p.mo.momz*P_MobjFlip(p.mo) > (8*FRACUNIT)*P_MobjFlip(p.mo) then return end
			if p.mo.momz*P_MobjFlip(p.mo) > (6*FRACUNIT)*P_MobjFlip(p.mo) then
				P_SetObjectMomZ(p.mo, p.jumpfactor*3/2, true)
			else
				P_SetObjectMomZ(p.mo, p.jumpfactor*6/2, true)
			end
		else
			if p.mo.momz*P_MobjFlip(p.mo) > (16*FRACUNIT)*P_MobjFlip(p.mo) then return end
			if p.mo.momz*P_MobjFlip(p.mo) > (12*FRACUNIT)*P_MobjFlip(p.mo) then
				P_SetObjectMomZ(p.mo, p.jumpfactor*3, true)
			else
				P_SetObjectMomZ(p.mo, p.jumpfactor*6, true)
			end
		end
		return true
	end
end)

addHook("SpinSpecial", function(p)
	if p.mo.health < 1 then return end
	if p.mo.skin ~= "spleenik" then return end
	if p.powers[pw_carry] then return end
	if (p.pflags & PF_STASIS) or (p.pflags & PF_JUMPSTASIS) or (p.pflags & PF_FULLSTASIS) then return false end
	if (p.SPLEENIKspintap) and (p.mo.eflags & MFE_UNDERWATER) and (not (p.pflags & PF_SLIDING)) and (not p.powers[pw_carry]) and not (P_IsObjectOnGround(p.mo) or p.SPLEENIKcrouch or p.SPLEENIKcrawl or p.SPLEENIKroll or p.SPLEENIKsprung) then
		p.mo.state = S_NSPLEENIK_SWIM
		if not p.powers[pw_super] then
			if p.mo.momz*P_MobjFlip(p.mo) < (-8*FRACUNIT)*P_MobjFlip(p.mo) then return end
			if p.mo.momz*P_MobjFlip(p.mo) < (-6*FRACUNIT)*P_MobjFlip(p.mo) then
				P_SetObjectMomZ(p.mo, -p.jumpfactor*3/2, true)
			else
				P_SetObjectMomZ(p.mo, -p.jumpfactor*6/2, true)
			end
		else
			if p.mo.momz*P_MobjFlip(p.mo) < (-16*FRACUNIT)*P_MobjFlip(p.mo) then return end
			if p.mo.momz*P_MobjFlip(p.mo) < (-12*FRACUNIT)*P_MobjFlip(p.mo) then
				P_SetObjectMomZ(p.mo, -p.jumpfactor*3, true)
			else
				P_SetObjectMomZ(p.mo, -p.jumpfactor*6, true)
			end
		end
		P_SpawnSkidDust(p, p.mo.radius/2, false)
		return true
	end
end)